"use strict";
cc._RF.push(module, 'db4fe2vUQRNDYwN4zMLOKn9', 'CopySpine');
// Script/ShareNode/CopySpine.js

"use strict";

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var CopyNode = require("./CopyNode");

var VFOneColor = cc.gfx.VertexFormat.XY_UV_Color;
var VFTwoColor = cc.gfx.VertexFormat.XY_UV_Two_Color;

var _mt4 = new cc.Mat4();

module.exports = /*#__PURE__*/function (_CopyNode) {
  _inheritsLoose(CopySpine, _CopyNode);

  function CopySpine() {
    return _CopyNode.apply(this, arguments) || this;
  }

  var _proto = CopySpine.prototype;

  _proto.fillBuffers = function fillBuffers(renderer) {
    this.checkBacth(renderer);
    var renderComp = this.shareNode._renderComponent; // 计算渲染数据数量

    var assembler = renderComp._assembler;
    var _assembler$_bufferOff = assembler._bufferOffsetInfo,
        startVertexOffset = _assembler$_bufferOff.startVertexOffset,
        startIndiceOffset = _assembler$_bufferOff.startIndiceOffset,
        endVertexOffset = _assembler$_bufferOff.endVertexOffset,
        endIndiceOffset = _assembler$_bufferOff.endIndiceOffset;
    var vertexCount = endVertexOffset - startVertexOffset;
    var indiceCount = endIndiceOffset - startIndiceOffset; // 准备填充复制节点的渲染数据

    var _useTint = renderComp.useTint || renderComp.isAnimationCached();

    var _vertexFormat = _useTint ? VFTwoColor : VFOneColor;

    var floatsPerVert = _vertexFormat._bytes >> 2; // 相关变量计算结束
    // 申请渲染数据空间、计算数据位移

    var _buffer = renderer.getBuffer('spine', _vertexFormat);

    var offsetInfo = _buffer.request(vertexCount, indiceCount);

    var indiceOffset = offsetInfo.indiceOffset,
        vertexOffset = offsetInfo.vertexOffset;
    var vertexFloatOffset = offsetInfo.byteOffset >> 2; // 复制vertices

    var vbuf = _buffer._vData;
    var startVbufIndex = startVertexOffset * floatsPerVert;

    for (var i = 0, len = vertexCount * floatsPerVert; i < len; i++) {
      vbuf[vertexFloatOffset + i] = vbuf[startVbufIndex + i];
    } // 修改位置


    var positionOffset = _vertexFormat.element("a_position").offset;

    var positionIndex = vertexFloatOffset + positionOffset;

    while (positionIndex < vertexFloatOffset + vertexCount * floatsPerVert) {
      vbuf[positionIndex] += this._disX;
      vbuf[positionIndex + 1] += this._disY;
      positionIndex += floatsPerVert;
    } // 填充indices


    var ibuf = _buffer._iData;

    for (var _i = 0; _i < indiceCount; _i++) {
      ibuf[indiceOffset + _i] = ibuf[startIndiceOffset + _i] - startVertexOffset + vertexOffset;
    }

    _buffer.adjust(vertexCount, indiceCount);
  }
  /**
   * 计算和共享节点的距离
   * 未开启合批时，会计算矩阵变换，需要将距离根据缩放进行逆换算。否则坐标错误。
   * @param {number} x x距离
   * @param {number} y y距离
   */
  ;

  _proto.calDis = function calDis(x, y) {
    var shareNode = this.shareNode;

    if (!shareNode._renderComponent.enableBatch) {
      shareNode.getWorldMatrix(_mt4);
      x /= _mt4.m[0];
      y /= _mt4.m[5];
    }

    this._disX = x;
    this._disY = y;
  };

  _proto.checkCanBacth = function checkCanBacth(renderer) {
    return this.shareNode === renderer.node;
  };

  return CopySpine;
}(CopyNode);

cc._RF.pop();