"use strict";
cc._RF.push(module, '2d368ke+upJEKLgzcR/skSB', 'CopyNode');
// Script/ShareNode/CopyNode.js

"use strict";

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var _nodeWorldPos = new cc.Vec2();

var _targetWorldPos = new cc.Vec2();

module.exports = /*#__PURE__*/function () {
  function CopyNode(shareNode, x, y) {
    this.shareNode = shareNode;
    this._disX = 0;
    this._disY = 0;
    this.position = new cc.Vec2();
  }

  var _proto = CopyNode.prototype;

  _proto.setParent = function setParent(parent) {
    this._parent = parent;
  };

  _proto.setPosition = function setPosition(x, y) {
    if (!this._parent) {
      CC_DEBUG && cc.warn("复制节点：请在设置父节点后，再修改位置");
      return;
    }

    x === undefined && (x = this.position.x);
    y === undefined && (y = this.position.y);
    this.position.x = x;
    this.position.y = y;

    this._parent.convertToWorldSpaceAR(this.position, _nodeWorldPos);

    this.shareNode.parent.convertToWorldSpaceAR(this.shareNode.position, _targetWorldPos);
    var disX = _nodeWorldPos.x - _targetWorldPos.x;
    var disY = _nodeWorldPos.y - _targetWorldPos.y;
    this.calDis(disX, disY);
  }
  /**
   * 计算和共享节点的距离
   * 有特殊需求可重写本函数
   * @param {number} x x距离
   * @param {number} y y距离
   */
  ;

  _proto.calDis = function calDis(x, y) {
    this._disX = x;
    this._disY = y;
  }
  /**
   * 检测是否可以合批
   */
  ;

  _proto.checkBacth = function checkBacth(renderer) {
    if (!this.checkCanBacth(renderer)) {
      this.flush(renderer);
      return;
    } // cocos内置检测逻辑


    var node = this.shareNode;
    var cullingMask = node._cullingMask;
    var material = node._renderComponent._materials[0];

    if (renderer.cullingMask !== cullingMask || material && material.getHash() !== renderer.material.getHash()) {
      this.flush(renderer);
    }
  }
  /**
   * 检测是否可以合批(子类可以继承拓展)
   */
  ;

  _proto.checkCanBacth = function checkCanBacth(renderer) {
    return true;
  }
  /**
   * 刷写渲染数据
   */
  ;

  _proto.flush = function flush(renderer) {
    renderer._flush();

    var node = this.shareNode;
    var material = node._renderComponent._materials[0];
    renderer.node = material.getDefine('CC_USE_MODEL') ? node : renderer._dummyNode;
    renderer.material = material;
    renderer.cullingMask = node._cullingMask;
  };

  _createClass(CopyNode, [{
    key: "x",
    get: function get() {
      return this.position._x;
    }
  }, {
    key: "y",
    get: function get() {
      return this.position._y;
    }
  }]);

  return CopyNode;
}();

cc._RF.pop();