"use strict";
cc._RF.push(module, 'b703bxvIABIEp45HeruP7kH', 'CopySprite');
// Script/ShareNode/CopySprite.js

"use strict";

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var CopyNode = require("./CopyNode");

module.exports = /*#__PURE__*/function (_CopyNode) {
  _inheritsLoose(CopySprite, _CopyNode);

  function CopySprite() {
    return _CopyNode.apply(this, arguments) || this;
  }

  var _proto = CopySprite.prototype;

  _proto.fillBuffers = function fillBuffers(renderer) {
    this.checkBacth(renderer);
    var renderComp = this.shareNode._renderComponent; // 获得共享节点的渲染数据

    var assembler = renderComp._assembler;
    var renderData = assembler._renderData;
    var vData = renderData.vDatas[0];
    var iData = renderData.iDatas[0]; // 申请渲染数据空间、计算数据位移

    var buffer = assembler.getBuffer(renderer);
    var verticesCount = assembler.verticesCount,
        floatsPerVert = assembler.floatsPerVert,
        indicesCount = assembler.indicesCount;
    var positionOffset = assembler.getVfmt().element("a_position").offset;
    var offsetInfo = buffer.request(verticesCount, indicesCount);
    var vertexOffset = offsetInfo.byteOffset >> 2,
        vbuf = buffer._vData; // 复制vertices

    var vbufLen = vbuf.length;

    if (vData.length + vertexOffset > vbufLen) {
      vbuf.set(vData.subarray(0, vbufLen - vertexOffset), vertexOffset);
    } else {
      vbuf.set(vData, vertexOffset);
    } // 修改位置


    for (var i = 0; i < verticesCount; i++) {
      var positionIndex = vertexOffset + i * floatsPerVert + positionOffset;

      if (positionIndex > vbufLen) {
        break;
      }

      vbuf[positionIndex] += this._disX;
      vbuf[positionIndex + 1] += this._disY;
    } // 填充indices


    var ibuf = buffer._iData,
        indiceOffset = offsetInfo.indiceOffset,
        vertexId = offsetInfo.vertexOffset;

    for (var _i = 0, l = iData.length; _i < l; _i++) {
      ibuf[indiceOffset++] = vertexId + iData[_i];
    }
  };

  return CopySprite;
}(CopyNode);

cc._RF.pop();